#ifndef BEZIER_PLUGIN_H
#define BEZIER_PLUGIN_H

extern void bezier_read_config(void);
extern void bezier_write_config(void);

extern void bezier_configure(void);
extern void bezier_set_tessellation_level(int level);
extern void bezier_set_camera_velocity(float velocity);
extern void bezier_set_camera_height(float height);
extern void bezier_set_fullscreen(gboolean fs);
extern void bezier_set_flat_shading(gboolean flat);
extern void bezier_set_draw_ground(gboolean draw);

typedef struct
{
  gint tessellation_level;
  float camera_velocity;
  float camera_height;
  gboolean fullscreen;
  gboolean flat_shading;
  gboolean draw_ground;
} bezier_config;

extern bezier_config bezier_cfg;

#endif
